commit 1c34981a9ba1f536118c0a2aa8b12e1a5288221c
Author: Jose E. Marchesi <jose.marchesi@oracle.com>
Date:   Mon Sep 14 20:35:22 2020 +0200

    bpf: use the expected instruction for NOPs
    
    The BPF ISA doesn't have a no-operation instruction, but in practice
    the Linux kernel verifier performs some optimizations that rely on
    these instructions to be encoded in a particular way.  As it turns
    out, we were using the "wrong" instruction in GCC.
    
    This patch makes GCC to generate the expected instruction for NOP (a
    `ja 0') and also adds a test to make sure this is the case.
    
    Tested in bpf-unknown-none targets.
    
    2020-09-14  Jose E. Marchesi  <jose.marchesi@oracle.com>
    
    gcc/
    
            * config/bpf/bpf.md ("nop"): Re-define as `ja 0'.
    
    gcc/testsuite/
    
            * gcc.target/bpf/nop-1.c: New test.
    
    (cherry picked from commit 5bcc0fa05ef713594f6c6d55d5c837e13a9c9803)

diff --git a/gcc/testsuite/gcc.target/bpf/nop-1.c b/gcc/testsuite/gcc.target/bpf/nop-1.c
new file mode 100644
index 00000000000..c4d274f6bad
--- /dev/null
+++ b/gcc/testsuite/gcc.target/bpf/nop-1.c
@@ -0,0 +1,14 @@
+/* { dg-do compile } */
+/* { dg-options "-std=gnu99 --patchable-function-entry=2,1" } */
+
+/* The purpose of this test is to make sure the right instruction is
+   generated for NOPs.  See bpf.md for a description on why this is
+   important.  */
+
+int
+foo ()
+{
+  return 0;
+}
+
+/* { dg-final { scan-assembler "foo:\n\t*ja\t0" } } */

